chiark / gitweb /
Various hacks to support use of Ed25519 keys in OpenSSH.
[profile] / setup
CommitLineData
65ff0e8c 1#! /bin/bash
f617db13
MW
2
3set -e
4
ce178f96
MW
5###--------------------------------------------------------------------------
6### Basic setup.
7
f617db13
MW
8umask 002
9
4aa875e9 10sub=
f617db13
MW
11mkdir -p $HOME$sub
12
563555cf 13: ${REPO=https://ftp.distorted.org.uk/pub/mdw/profile}
f617db13
MW
14
15export PATH=/usr/local/bin:$HOME$sub/bin:/usr/bin:/usr/ccs/bin:/bin
16
ce178f96
MW
17###--------------------------------------------------------------------------
18### Sort out command line.
19
f617db13
MW
20xstuff= false=
21while [ $# -gt 0 ]; do
22 case "$1" in
23 -x) xstuff=t;;
24 -n) false=false;;
25 --) shift; break;;
26 -*) echo >&2 "$0: bad option"; exit 1;;
27 *) break;;
28 esac
29 shift
30done
31
ce178f96
MW
32###--------------------------------------------------------------------------
33### Environment autoconfiguration.
34
35## Find out where I am
f617db13 36here=$(pwd)
f617db13 37
ce178f96 38## Suss out how to print things
f617db13
MW
39out=$(echo -n "foo"; echo "bar")
40if [ "$out" = "foobar" ]; then
41 echon="echo -n"
42 echoc=""
43else
44 echon="echo"
45 echoc='\c'
46fi
47
ce178f96 48## Find out how to fetch things over the net
f617db13
MW
49$echon "Finding URL fetcher:$echoc"
50if curl >/dev/null 2>&1 --version || [ $? -eq 2 ]; then
51 GETURL="curl -fs -o"
52 echo " curl."
53elif wget >/dev/null 2>&1 --version; then
54 GETURL="wget -q -O"
55 echo " wget."
56else
57 echo " failed!"
58 echo >&2 "$0: failed to find URL fetcher"
59 exit 1
60fi
61
ce178f96
MW
62###--------------------------------------------------------------------------
63### Create the necessary directories.
64
65echo "Creating directories..."
66for i in bin lib/emacs src; do
67 $echon " $i:$echoc"
68 if [ -d $HOME$sub/$i ]; then
69 echo " already exists."
70 else
71 mkdir -p $HOME$sub/$i
72 echo " done."
73 fi
74done
75echo " all done."
76
ce178f96
MW
77###--------------------------------------------------------------------------
78### Install some more complicated programs.
79
f617db13
MW
80echo "Installing packages..."
81systems="
285a1386
MW
82 mlib:crc-mktab
83 checkpath:tmpdir
f617db13
MW
84"
85[ "$xstuff" ] && systems="$systems
285a1386 86 xtoys:xatom
f617db13
MW
87"
88for system in $systems; do
89 set -- $(echo $system | tr : ' ')
285a1386 90 sys=$1 prog=$2
f617db13
MW
91 $echon " $sys:$echoc"
92 if $false $prog >/dev/null 2>&1 --version; then
93 echo " already installed."
94 else
95 ( set -e
96 $echon " downloading$echoc"
97 cd $HOME$sub/src
285a1386
MW
98 rm -rf $sys.tar.gz $sys-$ver
99 $GETURL $sys.tar.gz $REPO/$sys.tar.gz
f617db13 100 $echon " unpacking$echoc"
285a1386
MW
101 dir=$(gzip -cd $sys.tar.gz | tar tf - | head -1)
102 gzip -cd $sys.tar.gz | tar xf -
f617db13 103 $echon " configuring$echoc"
285a1386 104 cd $dir
f617db13
MW
105 mkdir build
106 cd build
188ebb31
MW
107 ../configure \
108 --prefix=$HOME$sub \
109 PKG_CONFIG_PATH=$HOME$sub/lib/pkgconfig \
110 >>buildlog 2>&1
f617db13
MW
111 $echon " building$echoc"
112 make >>buildlog 2>&1
113 $echon " installing$echoc"
114 make install >>buildlog 2>&1
115 echo " done."
116 )
117 fi
118done
852cd5fb 119echo " all done."
f617db13 120
ce178f96
MW
121###--------------------------------------------------------------------------
122### Install global configuration.
123
f141fe0f
MW
124echo -n "Installing dotfile configuration:"
125if [ -f $HOME$sub/.mdw.conf ]; then
126 echo " already installed."
127else
128 cp mdw.conf $HOME$sub/.mdw.conf
129 echo " done."
130fi
131
ce178f96 132## Symlink the various dotfiles into place
852cd5fb 133dotfiles="
be7dba95 134 bash_profile bash_logout bashrc inputrc bash_completion
54896c4f 135 emacs emacs-calc vm gnus.el ercrc.el
d8070b21 136 vimrc mg zile lesskey sqliterc
bb65ad08 137 parallel-config:.parallel/config
27be52b3 138 ipython_config.py:.ipython/profile_default/ipython_config.py
30169591 139 ditz-config
ce39049e 140 mailrc signature muttrc
ce178f96 141 cgrc tigrc
e7d23024 142 gdbinit
8a7e906d 143 guile
1d89ce86 144 rcrc
5d25e440 145 toprc
a6a6806a 146 mc-ini:.mc/ini mc-panels.ini:.mc/panels.ini
f56d38cd 147 pulse-daemon.conf:.pulse/daemon.conf
cbffcf2b 148 aspell.conf
78719982 149 tclshrc:.tclshrc tclshrc:.wishrc
ccaac00b
MW
150 lisp-init.lisp:.cmucl-init.lisp
151 lisp-init.lisp:.sbclrc
152 lisp-init.lisp:.clisprc.lisp
f6335a0c 153 lisp-init.lisp:.eclrc
b5bf3445 154 swank.lisp
5a91acc5 155 mdw-build.conf:.config/mdw-build.conf
3ec64a11 156 w3m-config:.w3m/config elinks.conf:.elinks/elinks.conf
4d60a7ac 157 dircolors colordiffrc screenrc tmux.conf cvsrc indent.pro"
739bccbf 158[ "$xstuff" ] && dotfiles="$dotfiles
f7cb5c84 159 xinitrc xsession xmodmap vncrc vncsession
5e23020b 160 fonts.conf
e517857c 161 stalonetrayrc
1c6b19d4 162 putty-defaults:.putty/sessions/Default%20Settings
2e60c7f3 163 mdw.session:.config/gnome-session/sessions/mdw.session
7cfa1f1a 164 eterm-theme.cfg:.Eterm/themes/Eterm/theme.cfg
739bccbf 165 e-keybindings.cfg:.enlightenment/keybindings.cfg
eae29a8c 166 evnc-keybindings.cfg:.enlightenment-vnc/keybindings.cfg
e8aee51b
MW
167 e16-bindings:.e16/bindings.cfg
168 gtkrc-2.0
169 gtk3.css:.config/gtk-3.0/gtk.css
170 gtk3-settings.ini:.config/gtk-3.0/settings.ini"
f617db13
MW
171echo "Installing dotfiles..."
172for d in $dotfiles; do
739bccbf
MW
173 target=.$d
174 case $d in
175 *:*) target=${d#*:} d=${d%%:*};;
176 esac
177 ft=$HOME$sub/$target
178 dir=${ft%/*}
179 mkdir -p $dir
99063107 180 ln -s $here/dot/$d $ft.new
739bccbf
MW
181 mv $ft.new $ft
182 echo " $target"
f617db13 183done
852cd5fb 184echo " all done."
f617db13 185
f7cb5c84
MW
186## CPP-hack files which need it.
187cppfiles=""
188[ "$xstuff" ] && cppfiles="$cppfiles
189 Xdefaults"
190echo "Hacking files with C preprocessor..."
c7203018 191defs="-DHOME=$HOME -DPROFILE=$here"
a1c9c51e 192defs="$defs -DEMACSWD=$(bin/mdw-conf emacs-width 77)"
f7cb5c84
MW
193for c in $cppfiles; do
194 target=.$c
195 case $c in
196 *:*) target=${c#*:} c=${c%%:*};;
197 esac
198 ft=$HOME$sub/$target
199 dir=${ft%/*}
200 mkdir -p $dir
c7203018 201 cpp -P $defs dot/$c -o $ft.new
f7cb5c84
MW
202 mv $ft.new $ft
203 echo " $target"
204done
205echo " all done."
206
403dc178
MW
207## Substitute things which need substituting.
208dotfilessubst="
209 gitconfig
8508a859 210 mykermrc
403dc178
MW
211 pulse-default.pa.in:.pulse/default.pa"
212echo "Installing dotfiles with substitutions..."
213for d in $dotfilessubst; do
214 case $d in
215 *:*) target=${d#*:} d=${d%%:*};;
216 *) target=.$d d=$d.in;;
217 esac
218 ft=$HOME$sub/$target
219 dir=${ft%/*}
220 mkdir -p $dir
221 sed "
2b5d4580
MW
2221i\\
223### generated by $here/setup; do not edit!\\
403dc178
MW
224
225/@home@/ s\a\a$HOME\ag
73165cde 226/@profile@/ s\a\a$here\ag
bf674ae1 227/@releasekey@/ s\a\a$(bin/mdw-conf releasekey 481334C2)\ag
403dc178
MW
228" dot/$d >$ft.new
229 mv $ft.new $ft
230 echo " $target"
231done
232echo " all done."
233
f4e43257 234## Symlink backgrounds.
b8d76a42 235backgrounds=$(cd bg && echo *)
f4e43257
MW
236if [ "$xstuff" ]; then
237 echo "Installing backgrounds..."
238 for b in $backgrounds; do
239 for e in enlightenment e16; do
240 dir=$HOME$sub/.$e/backgrounds
241 t=$dir/$b
242 mkdir -p $dir
99063107 243 ln -s $here/bg/$b $t.new
f4e43257
MW
244 mv $t.new $t
245 done
246 echo " $b"
247 done
248 echo " all done."
249fi
250
ce178f96
MW
251###--------------------------------------------------------------------------
252### Install useful scripts included in this package.
253
e04c4857 254scripts="
547fb8af 255 mdw-editor
b20bfd83 256 mdw-pager
b056f5c4 257 mdw-conf
b94830d9 258 mdw-build mdw-sbuild mdw-sbuild-server
5f56828b 259 update-buildable-branch
c4e84cb1 260 emacsclient-hack
8e08f814 261 movemail-hack
aaa2d943 262 sendmail-hack
68b2e9e6 263 aspell-hack
285a1386
MW
264 emerge-hack
265 lesspipe.sh
6a5170a8 266 run-with-shell-env
285a1386 267 start-ssh-agent
6a5170a8 268 start-ssh-pageant
6ffd4490 269 add-ssh-keys
4cdeb0d0 270 svnwrap
73bb9001 271 guest-console
4cdeb0d0 272 hyperspec"
8e08f814 273[ "$xstuff" ] && scripts="$scripts
3bdada49 274 xinitcmd
34a5ea4e 275 un-backslashify-selection
c02999e8 276 lock-screen
b7743290 277 xpra-start-xdummy
8e08f814 278 xshutdown"
e04c4857
MW
279echo "Installing scripts..."
280mkdir -p $HOME$sub/bin
281for s in $scripts; do
282 ft=$HOME$sub/bin/$s
99063107 283 ln -s $here/bin/$s $ft.new
e04c4857
MW
284 mv $ft.new $ft
285 echo " $s"
286done
287echo " all done."
288
4d7d040b
MW
289hacks="
290 ssh:ssh"
291echo "Installing hacks..."
292for h in $hacks; do
293 d=${h%%:*} h=${h#*:}
294 ft=$HOME$sub/bin/hacks/$d
295 mkdir -p $ft
296 ln -s $here/hacks/$h $ft/$h.new
297 mv $ft/$h.new $ft/$h
298 echo " $d:$h"
299done
300echo " all done."
301
ce178f96
MW
302###--------------------------------------------------------------------------
303### Set up the Emacs config.
304
65ff0e8c
MW
305$echon "Finding a suitable emacs:$echoc"
306emacs=no
936b7279 307for i in emacs24 emacs23 emacs22 emacs21 emacs; do
65ff0e8c
MW
308 if type -p >/dev/null $i; then
309 emacs=$i
310 break
311 fi
312done
313if [ $emacs = no ]; then
314 echo " failed."
315 emacs=:
316else
317 echo " $emacs."
318fi
319
f617db13 320echo "Installing Emacs packages..."
400223a1
MW
321emacspkg="
322 make-regexp
a1293ade 323 ew-hols
a3bdb4d9 324 mdw-gnus-patch
1778b496 325 git git-blame vc-git stgit
c6fe19d5 326 mdw-multiple-cursors
400223a1
MW
327 quilt"
328for elib in $emacspkg; do
f617db13 329 $echon " $elib:$echoc"
65ff0e8c 330 if $false $emacs >/dev/null 2>&1 --no-site-file --batch --eval '
20eb0692 331 (progn
852cd5fb
MW
332 (setq load-path (nconc load-path (list "~/lib/emacs")))
333 (kill-emacs (condition-case nil
334 (progn (load-library "'"$elib"'") 0)
20eb0692 335 (error 1))))'; then
f617db13
MW
336 echo " already installed."
337 else
99063107
MW
338 if [ -f el/$elib.el ]; then
339 cp el/$elib.el $HOME$sub/lib/emacs/$elib.el
a3bdb4d9
MW
340 else
341 $echon " downloading$echoc"
342 $GETURL $HOME$sub/lib/emacs/$elib.el $REPO/$elib.el
343 fi
f617db13
MW
344 $echon " compiling$echoc"
345 (cd $HOME$sub/lib/emacs;
65ff0e8c 346 $emacs >/dev/null 2>&1 --no-site-file --batch \
20eb0692 347 --eval '(byte-compile-file "'"$elib.el"'")')
f617db13
MW
348 echo " done."
349 fi
350done
852cd5fb 351echo " all done."
f617db13
MW
352
353$echon "Setting up Emacs configuration:$echoc"
354$echon " linking$echoc"
99063107 355for f in dot-emacs.el Makefile; do
f617db13 356 set -- $(echo $link | tr : ' ')
99063107
MW
357 ln -s $here/el/$f $HOME$sub/lib/emacs/$f.new
358 mv $HOME$sub/lib/emacs/$f.new $HOME$sub/lib/emacs/$f
f617db13
MW
359done
360$echon " compiling$echoc"
c39d1139 361{ cd $HOME$sub/lib/emacs && make EMACS=$emacs; } >/dev/null 2>&1
f617db13 362echo " done."
ce178f96
MW
363
364###----- That's all, folks --------------------------------------------------